#ifndef __avr_h__
#define __avr_h__

#define AT76C         10

#define AT90CAN128    30
#define AT90CAN32     31
#define AT90CAN64     32

#define AT90PWM2      50
#define AT90PWM2B     51
#define AT90PWM3      52
#define AT90PWM3B     53

#define AT90S1200     60
#define AT90S2313     61
#define AT90S2323     62
#define AT90S2343     63
#define AT90S4414     64
#define AT90S4433     65
#define AT90S4434     66
#define AT90S8515     67
#define AT90S8535     68

#define AT90USB1286   70
#define AT90USB1287   71
#define AT90USB162    72
#define AT90USB646    73
#define AT90USB647    74

#define ATmega128     101
#define ATmega1280    102
#define ATmega1281    103
#define ATmega16      104
#define ATmega161     105
#define ATmega162     106
#define ATmega163     107
#define ATmega164P    108
#define ATmega165     109
#define ATmega165P    110
#define ATmega168     111
#define ATmega168P    112
#define ATmega169     113
#define ATmega169P    114
#define ATmega2560    115
#define ATmega2561    116
#define ATmega32      117
#define ATmega323     118
#define ATmega324P    119
#define ATmega325     120
#define ATmega3250    121
#define ATmega3250P   122
#define ATmega325P    123
#define ATmega329     124
#define ATmega3290    125
#define ATmega3290P   126
#define ATmega329P    127
#define ATmega406     128
#define ATmega48      129
#define ATmega48P     130
#define ATmega64      131
#define ATmega640     132
#define ATmega644     133
#define ATmega644P    134
#define ATmega645     135
#define ATmega6450    136
#define ATmega649     137
#define ATmega6490    138
#define ATmega8       139
#define ATmega8515    140
#define ATmega8535    141
#define ATmega88      142
#define ATmega88P     143

#define ATtiny11      200
#define ATtiny12      201
#define ATtiny13      202
#define ATtiny15      203
#define ATtiny22      204
#define ATtiny2313    205
#define ATtiny24      206
#define ATtiny25      207
#define ATtiny26      208
#define ATtiny261     209
#define ATtiny28      210
#define ATtiny44      211
#define ATtiny45      212
#define ATtiny461     213
#define ATtiny84      214
#define ATtiny85      215
#define ATtiny861     216

#if   (__TARGET_PROCESSOR == AT76C)
#include                <AT76C.h>

#elif (__TARGET_PROCESSOR == AT90CAN128)
#include                <AT90CAN128.h>

#elif (__TARGET_PROCESSOR == AT90CAN32)
#include                <AT90CAN32.h>

#elif (__TARGET_PROCESSOR == AT90CAN64)
#include                <AT90CAN64.h>

#elif (__TARGET_PROCESSOR == AT90PWM2)
#include                <AT90PWM2.h>

#elif (__TARGET_PROCESSOR == AT90PWM2B)
#include                <AT90PWM2B.h>

#elif (__TARGET_PROCESSOR == AT90PWM3)
#include                <AT90PWM3.h>

#elif (__TARGET_PROCESSOR == AT90PWM3B)
#include                <AT90PWM3B.h>

#elif (__TARGET_PROCESSOR == AT90S1200)
#include                <AT90S1200.h>

#elif (__TARGET_PROCESSOR == AT90S2313)
#include                <AT90S2313.h>

#elif (__TARGET_PROCESSOR == AT90S2323)
#include                <AT90S2323.h>

#elif (__TARGET_PROCESSOR == AT90S2343)
#include                <AT90S2343.h>

#elif (__TARGET_PROCESSOR == AT90S4414)
#include                <AT90S4414.h>

#elif (__TARGET_PROCESSOR == AT90S4433)
#include                <AT90S4433.h>

#elif (__TARGET_PROCESSOR == AT90S4434)
#include                <AT90S4434.h>

#elif (__TARGET_PROCESSOR == AT90S8515)
#include                <AT90S8515.h>

#elif (__TARGET_PROCESSOR == AT90S8535)
#include                <AT90S8535.h>

#elif (__TARGET_PROCESSOR == AT90USB1286)
#include                <AT90USB1286.h>

#elif (__TARGET_PROCESSOR == AT90USB1287)
#include                <AT90USB1287.h>

#elif (__TARGET_PROCESSOR == AT90USB162)
#include                <AT90USB162.h>

#elif (__TARGET_PROCESSOR == AT90USB646)
#include                <AT90USB646.h>

#elif (__TARGET_PROCESSOR == AT90USB647)
#include                <AT90USB647.h>

#elif (__TARGET_PROCESSOR == ATmega128)
#include                <ATmega128.h>

#elif (__TARGET_PROCESSOR == ATmega1280)
#include                <ATmega1280.h>

#elif (__TARGET_PROCESSOR == ATmega1281)
#include                <ATmega1281.h>

#elif (__TARGET_PROCESSOR == ATmega16) 
#include                <ATmega16.h>

#elif (__TARGET_PROCESSOR == ATmega161)
#include                <ATmega161.h>

#elif (__TARGET_PROCESSOR == ATmega162)
#include                <ATmega162.h>

#elif (__TARGET_PROCESSOR == ATmega163)
#include                <ATmega163.h>

#elif (__TARGET_PROCESSOR == ATmega164P)
#include                <ATmega164P.h>

#elif (__TARGET_PROCESSOR == ATmega165)
#include                <ATmega165.h>

#elif (__TARGET_PROCESSOR == ATmega165P)
#include                <ATmega165P.h>

#elif (__TARGET_PROCESSOR == ATmega168)
#include                <ATmega168.h>

#elif (__TARGET_PROCESSOR == ATmega168P)
#include                <ATmega168P.h>

#elif (__TARGET_PROCESSOR == ATmega169)
#include                <ATmega169.h>

#elif (__TARGET_PROCESSOR == ATmega169P)
#include                <ATmega169P.h>

#elif (__TARGET_PROCESSOR == ATmega2560)
#include                <ATmega2560.h>

#elif (__TARGET_PROCESSOR == ATmega2561)
#include                <ATmega2561.h>

#elif (__TARGET_PROCESSOR == ATmega32)
#include                <ATmega32.h>

#elif (__TARGET_PROCESSOR == ATmega323)
#include                <ATmega323.h>

#elif (__TARGET_PROCESSOR == ATmega324P)
#include                <ATmega324P.h>

#elif (__TARGET_PROCESSOR == ATmega325)
#include                <ATmega325.h>

#elif (__TARGET_PROCESSOR == ATmega3250)
#include                <ATmega3250.h>

#elif (__TARGET_PROCESSOR == ATmega3250P)
#include                <ATmega3250P.h>

#elif (__TARGET_PROCESSOR == ATmega325P)
#include                <ATmega325P.h>

#elif (__TARGET_PROCESSOR == ATmega329)
#include                <ATmega329.h>

#elif (__TARGET_PROCESSOR == ATmega3290)
#include                <ATmega3290.h>

#elif (__TARGET_PROCESSOR == ATmega3290P)
#include                <ATmega3290P.h>

#elif (__TARGET_PROCESSOR == ATmega329P)
#include                <ATmega329P.h>

#elif (__TARGET_PROCESSOR == ATmega406)
#include                <ATmega406.h>

#elif (__TARGET_PROCESSOR == ATmega48)
#include                <ATmega48.h>

#elif (__TARGET_PROCESSOR == ATmega48P)
#include                <ATmega48P.h>

#elif (__TARGET_PROCESSOR == ATmega64)
#include                <ATmega64.h>

#elif (__TARGET_PROCESSOR == ATmega640)
#include                <ATmega640.h>

#elif (__TARGET_PROCESSOR == ATmega644)
#include                <ATmega644.h>

#elif (__TARGET_PROCESSOR == ATmega644P)
#include                <ATmega644P.h>

#elif (__TARGET_PROCESSOR == ATmega645)
#include                <ATmega645.h>

#elif (__TARGET_PROCESSOR == ATmega6450)
#include                <ATmega6450.h>

#elif (__TARGET_PROCESSOR == ATmega649)
#include                <ATmega649.h>

#elif (__TARGET_PROCESSOR == ATmega6490)
#include                <ATmega6490.h>

#elif (__TARGET_PROCESSOR == ATmega8)
#include                <ATmega8.h>

#elif (__TARGET_PROCESSOR == ATmega8515)
#include                <ATmega8515.h>

#elif (__TARGET_PROCESSOR == ATmega8535)
#include                <ATmega8535.h>

#elif (__TARGET_PROCESSOR == ATmega88)
#include                <ATmega88.h>

#elif (__TARGET_PROCESSOR == ATmega88P)
#include                <ATmega88P.h>

#elif (__TARGET_PROCESSOR == ATtiny11)
#include                <ATtiny11.h>

#elif (__TARGET_PROCESSOR == ATtiny12)
#include                <ATtiny12.h>

#elif (__TARGET_PROCESSOR == ATtiny13)
#include                <ATtiny13.h>

#elif (__TARGET_PROCESSOR == ATtiny15)
#include                <ATtiny15.h>

#elif (__TARGET_PROCESSOR == ATtiny22)
#include                <ATtiny22.h>

#elif (__TARGET_PROCESSOR == ATtiny2313)
#include                <ATtiny2313.h>

#elif (__TARGET_PROCESSOR == ATtiny24)
#include                <ATtiny24.h>

#elif (__TARGET_PROCESSOR == ATtiny25)
#include                <ATtiny25.h>

#elif (__TARGET_PROCESSOR == ATtiny26)
#include                <ATtiny26.h>

#elif (__TARGET_PROCESSOR == ATtiny261)
#include                <ATtiny261.h>

#elif (__TARGET_PROCESSOR == ATtiny28)
#include                <ATtiny28.h>

#elif (__TARGET_PROCESSOR == ATtiny44)
#include                <ATtiny44.h>

#elif (__TARGET_PROCESSOR == ATtiny45)
#include                <ATtiny45.h>

#elif (__TARGET_PROCESSOR == ATtiny461)
#include                <ATtiny461.h>

#elif (__TARGET_PROCESSOR == ATtiny84)
#include                <ATtiny84.h>

#elif (__TARGET_PROCESSOR == ATtiny85)
#include                <ATtiny85.h>

#elif (__TARGET_PROCESSOR == ATtiny861)
#include                <ATtiny861.h>

#endif

#define __IOADDRESS(SFRADDRESS) ((SFRADDRESS)-0x20)

#if (__TARGET_PROCESSOR == ATmega165) || (__TARGET_PROCESSOR == ATmega169) || (__TARGET_PROCESSOR == ATmega325) || (__TARGET_PROCESSOR == ATmega329) || (__TARGET_PROCESSOR == ATmega645)

#define UDR UDR0
#define UBRRH UBRR0H
#define UBRRL UBRR0L
#define UCSRC UCSR0C
#define UCPOL UCPOL0
#define UCPOL_BIT UCPOL0_BIT
#define UCPOL_MASK UCPOL0_MASK
#define UCSZ0 UCSZ00
#define UCSZ0_BIT UCSZ00_BIT
#define UCSZ0_MASK UCSZ00_MASK
#define UCSZ1 UCSZ01
#define UCSZ1_BIT UCSZ01_BIT
#define UCSZ1_MASK UCSZ01_MASK
#define USBS USBS0
#define USBS_BIT USBS0_BIT
#define USBS_MASK USBS0_MASK
#define UPM0 UPM00
#define UPM0_BIT UPM00_BIT
#define UPM0_MASK UPM00_MASK
#define UPM1 UPM01
#define UPM1_BIT UPM01_BIT
#define UPM1_MASK UPM01_MASK 
#define UMSEL UMSEL0
#define UMSEL_BIT UMSEL0_BIT
#define UMSEL_MASK UMSEL0_MASK

#define UCSRB UCSR0B
#define TXB8 TXB80
#define TXB8_BIT TXB80_BIT
#define TXB8_MASK TXB80_MASK
#define RXB8 RXB80
#define RXB8_BIT RXB80_BIT
#define RXB8_MASK RXB80_MASK
#define UCSZ2 UCSZ02
#define UCSZ2_BIT UCSZ02_BIT
#define UCSZ2_MASK UCSZ02_MASK
#define TXEN TXEN0
#define TXEN_BIT TXEN0_BIT
#define TXEN_MASK TXEN0_MASK 
#define RXEN RXEN0
#define RXEN_BIT RXEN0_BIT
#define RXEN_MASK RXEN0_MASK
#define UDRIE UDRIE0
#define UDRIE_BIT UDRIE0_BIT
#define UDRIE_MASK UDRIE0_MASK
#define TXCIE TXCIE0
#define TXCIE_BIT TXCIE0_BIT
#define TXCIE_MASK TXCIE0_MASK
#define RXCIE RXCIE0
#define RXCIE_BIT RXCIE0_BIT
#define RXCIE_MASK RXCIE0_MASK

#define UCSRA UCSR0A
#define MPCM MPCM0
#define MPCM_BIT MPCM0_BIT
#define MPCM_MASK MPCM0_MASK
#define U2X U2X0
#define U2X_BIT U2X0_BIT
#define U2X_MASK U2X0_MASK
#define UPE UPE0
#define UPE_BIT UPE0_BIT
#define UPE_MASK UPE0_MASK
#define DOR DOR0
#define DOR_BIT DOR0_BIT
#define DOR_MASK DOR0_MASK
#define FE FE0
#define FE_BIT FE0_BIT
#define FE_MASK FE0_MASK
#define UDRE UDRE0
#define UDRE_BIT UDRE0_BIT
#define UDRE_MASK UDRE0_MASK
#define TXC TXC0
#define TXC_BIT TXC0_BIT
#define TXC_MASK TXC0_MASK
#define RXC RXC0
#define RXC_BIT RXC0_BIT
#define RXC_MASK RXC0_MASK

#endif

#endif
